#include "stdafx.h"
#include "CpIspProgress.h"
#include <stdio.h>


void Gotoxy(int x, int y)
{
	printf("%c[%d;%df", 0x1B, y, x);
}

CCpIspProgress::CCpIspProgress()
	:ulMin(0), ulMax(1), ulStep(1), ulCurrentIndex(0), bEnablePrint(FALSE)
{
}

CCpIspProgress::~CCpIspProgress()
{

}

void CCpIspProgress::StepIt()
{
	DWORD ulProgress = 0;
	if(bEnablePrint)
	{
		fflush(stdout);
		Gotoxy(0, 1000);
		ulCurrentIndex += ulStep;
		if(ulCurrentIndex >= ulMax)
		{
			ulProgress = 100;
		}
		else
		{
			ulProgress = (ulCurrentIndex - ulMin) * 100 / (ulMax - ulMin);
		}

		cout << "ISP Progress: " << ulProgress << "%";
		fflush(stdout);
	}
}

DWORD CCpIspProgress::GetCurrentProgress()
{
	DWORD ulProgress = 0;
	if(ulCurrentIndex >= ulMax)
	{
		ulProgress = 100;
	}
	else
	{
		ulProgress = (ulCurrentIndex - ulMin) * 100 / (ulMax - ulMin);
	}
	return ulProgress;
}

BOOL CCpIspProgress::SetRange(DWORD ulMinNum, DWORD ulMaxNum)
{
	if(ulMinNum >= ulMaxNum)
	{
		return FALSE;
	}
	ulMin = ulMinNum;
	ulMax = ulMaxNum;
	ulCurrentIndex = ulMinNum;
	return TRUE;
}

void CCpIspProgress::SetStep(DWORD ulStepNum)
{
	ulStep = ulStepNum;
}

void CCpIspProgress::SetPrintSwitch(BOOL bEnable)
{
	bEnablePrint = bEnable;
}

void CCpIspProgress::SetRecordResultSwitch(BOOL bEnable)
{
	bEnableRecordResult = bEnable;
}

BOOL CCpIspProgress::GetPrintSwitch()
{
	return bEnablePrint;
}

BOOL CCpIspProgress::GetRecordResultSwitch()
{
	return bEnableRecordResult;
}


void CCpIspProgress::ReocordISPResult(string strPath, DWORD ulProgress)
{
	CHAR cszCurrentDir[MAX_DIR_LENGTH] = { 0 };
	string strPathPlusName;
	CHAR cszIspResult[] = "ISPResult.txt";

	if(bEnableRecordResult)
	{
		strPathPlusName = strPath + cszIspResult;
		strncpy(cszCurrentDir, strPathPlusName.c_str(), sizeof(cszCurrentDir));

		fstream fileLog(cszCurrentDir, ios::out);
		if(fileLog.is_open())
		{
			fileLog << "ISP Progress :" << ulProgress << "%" << endl;
		}
		fileLog.close();
	}
}