#include "stdafx.h"
#include "CpIsp.h"
#include "CPISPCommon/CpIspFunc.h"
#include "../Tool_Common/CommonDefine/CommonDefine.h"
#include "../Tool_Common/CpRsFuncBase.h"
#include "../Tool_Common/CpRsString.h"
#include "CPISPCommon/CpIspShare.h"
#ifdef _CPISP_H

CHAR Version[20] = "LIBISP_1.0.0";
CCpRsComm * g_pcpRsComm = NULL;
CCpRsString g_cpstrPath;
CCpIspFlowSetting *g_pcpIspSetting;

#define IS_ISP_FLASH_FUNC(FuncType) ((FuncType == _ENUM_FUNC_ERASE) \
|| (FuncType == _ENUM_FUNC_ISP_NORMAL) || (FuncType == _ENUM_FUNC_ISP_NORMAL_HW_SIGN) || (FuncType == _ENUM_FUNC_ISP_NORMAL_SW_SIGN)\
|| (FuncType == _ENUM_FUNC_ISP_FW_PARTITION) || (FuncType == _ENUM_FUNC_ISP_FW_PARTITION_HW_SIGN) || (FuncType == _ENUM_FUNC_ISP_FW_PARTITION_SW_SIGN) \
|| (FuncType == _ENUM_FUNC_ISP_DIFFER_BANK) || (FuncType == _ENUM_FUNC_ISP_DIFFER_BANK_HW_SIGN) || (FuncType == _ENUM_FUNC_ISP_DIFFER_BANK_SW_SIGN)\
|| (FuncType == _ENUM_FUNC_ISP_COPY_BANK) || (FuncType == _ENUM_FUNC_ISP_COPY_BANK_HW_SIGN) || (FuncType == _ENUM_FUNC_ISP_COPY_BANK_SW_SIGN))


void ModifySettingByCmd(STRUCT_CP_ISP_COMMAND_SETTING &stCmdSetting)
{
    // modify command setting
    g_pcpIspSetting->SetIspFunctionType(stCmdSetting.enumFuncType);
    if(stCmdSetting.mapFw.size() > 0)
    {
        g_pcpIspSetting->SetProgramFwMap(stCmdSetting.mapFw);
    }
    
    if(stCmdSetting.nAutoSlave != -1)
    {
        g_pcpIspSetting->SetAutoDetectSlave((BOOL)stCmdSetting.nAutoSlave);
        if(stCmdSetting.nAutoSlave)
        {
            g_pcpIspSetting->SetSpecifiedSlave(stCmdSetting.ucSlaveAddr);
        }
    }

    g_pcpIspSetting->SetBootFlag(stCmdSetting.stFlag);
    g_pcpIspSetting->SetReadVerSetting(stCmdSetting.stReadVer);
}

STRUCT_ENUM_ERROR_TYPE IspFlash(STRUCT_CP_ISP_COMMAND_SETTING &stCmdSetting)
{
    STRUCT_ENUM_ERROR_TYPE enumError = _ERROR_SUCCESS;

    g_cpstrPath = GetCurrentProcessDir(NULL);

    // Load setting.ini
    CCpIspFlowSetting cpIspSetting;

    g_pcpIspSetting = &cpIspSetting;
    ModifySettingByCmd(stCmdSetting);

    enumError = CheckRsComm(stCmdSetting);

    if(g_pcpIspSetting->GetIspFunctionType() != _ENUM_FUNC_UNKNOWN)
    {
        if(IS_ISP_FLASH_FUNC(g_pcpIspSetting->GetIspFunctionType()))
        {
            enumError = DoIsp();
        }        
    }

    if(stCmdSetting.stReadVer.bNeedRead)
    {
       Sleep(g_pcpIspSetting->GetTimeAfterReset());
       //Read version 
       enumError = ReadFWVersion();
    }
    return enumError;
}

void SetCommInterface(CCpRsComm *pRsComm)
{
    g_pcpRsComm = pRsComm;
}

#endif
