#include <stdio.h>
#include <dlfcn.h>

#include "CPComm_PlugIn_Define/CpCommPlugInExport.h"

void *g_hDeviceDll = NULL;

BOOL rsdLoadDeviceDllFile(TCHAR * pFileName)
{

	rsdFreeDeviceDllFile();

	g_hDeviceDll  = dlopen(pFileName, RTLD_NOW);
    if(g_hDeviceDll == NULL)
    {
    	fprintf(stderr, "Failed to open libaray %s error:%s\n", pFileName, dlerror());
    	return _ERROR_COMM_LOADDLL_FAIL;
    }
    rsdInitialDev = (func_rsdInitialDev)dlsym(g_hDeviceDll, "InitialDev");
	if(rsdInitialDev == NULL)
	{
        printf("rsdInitialDev Fail\n");
		rsdFreeDeviceDllFile();
    	return _ERROR_COMM_LOADDLL_FAIL;
	}

	rsdReleaseDev = (func_rsdReleaseDev)dlsym(g_hDeviceDll, "ReleaseDev");
	if(rsdReleaseDev == NULL)
	{
        printf("rsdReleaseDev Fail\n");
		rsdFreeDeviceDllFile();
    	return _ERROR_COMM_LOADDLL_FAIL;
	}

    rsdGetCommID = (func_rsdGetCommID)dlsym(g_hDeviceDll, "GetCommID");
    if(rsdGetCommID == NULL)
    {
        printf("rsdGetCommID Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetCommName = (func_rsdGetCommName)dlsym(g_hDeviceDll, "GetCommName");
    if(rsdGetCommName == NULL)
    {
        printf("rsdGetCommName Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetI2CPageLength = (func_rsdGetI2CPageLength)dlsym(g_hDeviceDll, "GetI2CPageLength");
    if(rsdGetI2CPageLength == NULL)
    {
        printf("rsdGetI2CPageLength Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetNativePageLength = (func_rsdGetNativePageLength)dlsym(g_hDeviceDll, "GetNativePageLength");
    if(rsdGetNativePageLength == NULL)
    {
        printf("rsdGetNativePageLength Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CWrite = (func_rsdI2CWrite)dlsym(g_hDeviceDll, "I2CWrite");
    if(rsdI2CWrite == NULL)
    {
        printf("rsdI2CWrite Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CRead = (func_rsdI2CRead)dlsym(g_hDeviceDll, "I2CRead");
    if(rsdI2CRead == NULL)
    {
        printf("rsdI2CRead Fail\n");

        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CWriteByte = (func_rsdI2CWriteByte)dlsym(g_hDeviceDll, "I2CWriteByte");
    if(rsdI2CWriteByte == NULL)
    {
        printf("rsdI2CWriteByte Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CCurrentRead = (func_rsdI2CCurrentRead)dlsym(g_hDeviceDll, "I2CCurrentRead");
    if(rsdI2CCurrentRead == NULL)
    {
        printf("rsdI2CCurrentRead Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CWordWrite = (func_rsdI2CWordWrite)dlsym(g_hDeviceDll, "I2CWordWrite");
    if(rsdI2CWordWrite == NULL)
    {
        printf("rsdI2CWordWrite Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CWordRead = (func_rsdI2CWordRead)dlsym(g_hDeviceDll, "I2CWordRead");
    if(rsdI2CWordRead == NULL)
    {
        printf("rsdI2CWordRead Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdAdjustOption = (func_rsdAdjustOption)dlsym(g_hDeviceDll, "AdjustOption");
    if(rsdAdjustOption == NULL)
    {
        printf("rsdAdjustOption Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetI2CSpeed = (func_rsdSetI2CSpeed)dlsym(g_hDeviceDll, "SetI2CSpeed");
    if(rsdSetI2CSpeed == NULL)
    {
        printf("rsdSetI2CSpeed Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetI2CSpeed = (func_rsdGetI2CSpeed)dlsym(g_hDeviceDll, "GetI2CSpeed");
    if(rsdGetI2CSpeed == NULL)
    {
        printf("rsdGetI2CSpeed Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetAuxMode = (func_rsdSetAuxMode)dlsym(g_hDeviceDll, "SetAuxMode");
    if(rsdSetAuxMode == NULL)
    {
        printf("rsdSetAuxMode Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetUsbWaitingMode = (func_rsdSetWaitingMode)dlsym(g_hDeviceDll, "SetWaitingMode");
    if(rsdSetUsbWaitingMode == NULL)
    {
        printf("rsdSetUsbWaitingMode Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetWaitingMode = (func_rsdGetWaitingMode)dlsym(g_hDeviceDll, "GetWaitingMode");
    if(rsdGetWaitingMode == NULL)
    {
        printf("rsdGetWaitingMode Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdNativeWrite = (func_rsdNativeWrite)dlsym(g_hDeviceDll, "NativeWrite");
    if(rsdNativeWrite == NULL)
    {
        printf("rsdNativeWrite Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdNativeRead = (func_rsdNativeRead)dlsym(g_hDeviceDll, "NativeRead");
    if(rsdNativeRead == NULL)
    {
        printf("rsdNativeRead Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetConfigFilePath = (func_rsdSetConfigFilePath)dlsym(g_hDeviceDll, "SetSettingFilePath");
    if(rsdSetConfigFilePath == NULL)
    {
        printf("rsdSetConfigFilePath Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetDeviceHandler = (func_rsdGetDeviceHandler)dlsym(g_hDeviceDll, "GetDeviceHandler");
    if(rsdGetDeviceHandler == NULL)
    {
        printf("rsdGetDeviceHandler Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdResetFirmware = (func_rsdResetFirmware)dlsym(g_hDeviceDll, "ResetFirmware");
    if(rsdResetFirmware == NULL)
    {
        printf("rsdResetFirmware Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }
    rsdGetSMBUSDataType = (func_rsdGetSMBUSDataType)dlsym(g_hDeviceDll, "GetSMBUSDataType");
    if(rsdGetSMBUSDataType == NULL)
    {
        printf("rsdGetSMBUSDataType Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }
    rsdSetSMBUSDataType = (func_rsdSetSMBUSDataType)dlsym(g_hDeviceDll, "SetSMBUSDataType");
    if(rsdSetSMBUSDataType == NULL)
    {
        printf("rsdSetSMBUSDataType Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }
    rsdGetDeviceCount = (func_rsdGetDeviceCount)dlsym(g_hDeviceDll, "GetDeviceCount");
    if(rsdGetDeviceCount == NULL)
    {
        printf("rsdGetDeviceCount Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }
    rsdRemoveDevice = (func_rsdRemoveDevice)dlsym(g_hDeviceDll, "RemoveDevice");
    if(rsdRemoveDevice == NULL)
    {
        printf("rsdRemoveDevice Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetFTDIGetAck = (func_rsdSetFTDIGetAck)dlsym(g_hDeviceDll, "SetFTDIGetAck");
    if(rsdSetFTDIGetAck == NULL)
    {
        printf("rsdSetFTDIGetAck Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetFTDIGetAckStatus = (func_rsdGetFTDIGetAckStatus)dlsym(g_hDeviceDll, "GetFTDIGetAckStatus");
    if(rsdGetFTDIGetAckStatus == NULL)
    {
        printf("rsdGetFTDIGetAckStatus Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdGetUsbDevicePath = (func_rsdGetUsbDevicePath)dlsym(g_hDeviceDll, "GetUsbDevicePath");
    if(rsdGetUsbDevicePath == NULL)
    {
        printf("rsdGetUsbDevicePath Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSelectUsbByDevicePath = (func_rsdSelectUsbByDevicePath)dlsym(g_hDeviceDll, "SelectUsbByDevicePath");
    if(rsdSelectUsbByDevicePath == NULL)
    {
        printf("rsdSelectUsbByDevicePath Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }
    rsdSelectUsbByIndex = (func_rsdSelectUsbByIndex)dlsym(g_hDeviceDll, "SelectUsbByIndex");
    if(rsdSelectUsbByIndex == NULL)
    {
        printf("rsdSelectUsbByIndex Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSetCmdLine = (func_rsdSetCmdLine)dlsym(g_hDeviceDll, "SetCmdLine");
    if(rsdSetCmdLine == NULL)
    {
        printf("rsdSetCmdLine Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CWriteSegment = (func_rsdI2CWriteSegment)dlsym(g_hDeviceDll, "I2CWriteSegment");
    if(rsdI2CWriteSegment == NULL)
    {
        printf("rsdI2CWriteSegment Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdI2CReadSegment = (func_rsdI2CReadSegment)dlsym(g_hDeviceDll, "I2CReadSegment");
    if(rsdI2CReadSegment == NULL)
    {
        printf("rsdI2CReadSegment Fail\n");
        rsdFreeDeviceDllFile();
        return FALSE;
    }

    rsdSendUsbPacket = (func_rsdSendUsbPacket)dlsym(g_hDeviceDll, "SendUsbPacket");
	if(rsdSendUsbPacket == NULL)
	{   
        printf("rsdSendUsbPacket Fail\n");
		rsdFreeDeviceDllFile();
    	return _ERROR_COMM_LOADDLL_FAIL;
	}    
    rsdReceiveUsbPacket = (func_rsdReceiveUsbPacket)dlsym(g_hDeviceDll, "ReceiveUsbPacket");
	if(rsdReceiveUsbPacket == NULL)
	{
        printf("rsdReceiveUsbPacket Fail\n");
		rsdFreeDeviceDllFile();
    	return _ERROR_COMM_LOADDLL_FAIL;
	}
	return TRUE;
}

void rsdFreeDeviceDllFile()
{
	if (g_hDeviceDll  == NULL)
    {
        return;
    }
	
	dlclose(g_hDeviceDll);
    g_hDeviceDll = NULL;
}
