#ifndef _ERROR_DEFINE_H_
#define _ERROR_DEFINE_H_

//////////////////////////////////////////////////////////////////////////
// Error message used in whole system
//////////////////////////////////////////////////////////////////////////
typedef enum
{
    _ERROR_START = 0,
    _ERROR_SUCCESS = _ERROR_START,
    _ERROR_COMMONFUNC_CMD,
    _ERROR_COMMONFUNC_OUTPUT,
    _ERROR_COMMONFUNC_POLLINGFAIL,
    _ERROR_COMM_NOTEXIST, // 4
    _ERROR_COMM_LOADDLL_FAIL,//5
    _ERROR_COMM_NO_INITIAL,
    _ERROR_COMM_PARAMETER,
    _ERROR_COMM_UNSUPPORT_DEBUGMODE,
    _ERROR_COMM_SET_IICADDR, 
    _ERROR_COMM_ENTER_ISP_MODE,//10
    _ERROR_COMM_UNSUPPORT_MCUREGACCESSMODE,
    _ERROR_COMM_AUTO_DETECT_SLAVE_ADDRESS_FAIL,
    _ERROR_COMM_DDCCI_READ_CHECKSUM_ERROR,
    _ERROR_COMM_DDCCI_READ_SLAVE_ADDRESS,
    _ERROR_COMM_DDCCI_CMD_ERROR,//15
    _ERROR_COMM_I2C_MASTER_BUFFER_SIZE,
    _ERROR_COMM_I2C_MASTER_SUBADDR_NOT_SUPPORT,
    _ERROR_COMM_DLLFUNCTION_EXPORT,
    _ERROR_COMM_UNSUPPORT_COMM_TYPE,
    _ERROR_COMM_RW_REG_PAGE_LEN,
    _ERROR_COMM_RW_REG_CHECKSUM,
    _ERROR_COMM_RW_REG_COMMAND,
    _ERROR_COMM_I2C_SEGMENT_NOT_SUPPORT,
    _ERROR_COMM_NOT_SUPPORT,


    _ERROR_PLUGIN_EDPISP_ENTERNISP = 0x100,
    _ERROR_PLUGIN_EDPISP_OPENFWFILE,
    _ERROR_PLUGIN_EDPISP_OPENEDIDFILE,
    _ERROR_PLUGIN_EDPISP_OPENFILELENGTH,
    _ERROR_PLUGIN_EDPISP_SCALERTYPE,
    _ERROR_PLUGIN_EDPISP_CHECKEDIDFILE,
    _ERROR_PLUGIN_EDPISP_RESETBOOTLOADER,
    _ERROR_PLUGIN_EDPISP_FIRSTBYTECHECK,
    _ERROR_PLUGIN_EDPISP_1STEEPROMCHECK,
    _ERROR_PLUGIN_EDPISP_2NDEEPROMCHECK,
    _ERROR_PLUGIN_EDPISP_CHECKI2CSTATUS,
    _ERROR_PLUGIN_EDPISP_USERSTOP,
    _ERROR_PLUGIN_EDPISP_IICCMDINCOMPLETE,

    _ERROR_PLUGIN_CTRLREG_COMMON_PORT = 0x200,
    _ERROR_PLUGIN_CTRLREG_COMMON_PAGE,
    _ERROR_PLUGIN_CTRLREG_PAGESELECTNOTFIND,
    _ERROR_PLUGIN_CTRLREG_PAGEDATANOTFIND,
    _ERROR_PLUGIN_CTRLREG_UNSUPPORT_PORTINPORT,
    _ERROR_PLUGIN_CTRLREG_UNSUPPORT_PAGEINPAGE,
    _ERROR_PLUGIN_CTRLREG_REGNAME,
    _ERROR_PLUGIN_CTRLREG_WRITEREG,
    _ERROR_PLUGIN_CTRLREG_USERSTOP,
    _ERROR_PLUGIN_CTRLREG_UNPORT,
    _ERROR_PLUGIN_CTRLREG_SCALERTYPE,
    _ERROR_PLUGIN_CTRLREG_READ_PORT_FAIL,
    _ERROR_PLUGIN_CTRLREG_PROCESS_QUIT,
    _ERROR_PLUGIN_CTRLREG_FIND_NO_MCU_PAGE,
    _ERROR_PLUGIN_CTRLREG_ADDR_OUT_OF_RANGE,
    _ERROR_PLUGIN_CTRLREG_INIT_EXCEL_FAIL,
    _ERROR_PLUGIN_CTRLREG_UFP_CAN_NOT_READ_WRITE,
    _ERROR_PLUGIN_CTRLREG_DFP_CAN_NOT_READ_WRITE,

    _ERROR_PLUGIN_MCU_ENTERISP = 0x300,
    _ERROR_PLUGIN_MCU_PARAMETER,
    _ERROR_PLUGIN_MCU_OPENFILE,
    _ERROR_PLUGIN_MCU_USERSTOP,
    _ERROR_PLUGIN_MCU_DEBUG_MODE_ERROR,
    _ERROR_PLUGIN_MCU_SELECT_FILE,
    _ERROR_PLUGIN_MCU_REGISTER_WRTIE,

    _ERROR_PLUGIN_EFUSE_OPENFILE = 0x400,
    _ERROR_PLUGIN_EFUSE_FILETYPE,
    _ERROR_PLUGIN_EFUSE_LOCKEFUSE,
    _ERROR_PLUGIN_EFUSE_ISPTIMES,
    _ERROR_PLUGIN_EFUSE_ISPBIT,
    _ERROR_PLUGIN_EFUSE_PROGRAMBIT,
    _ERROR_PLUGIN_EFUSE_UNLOCKEFUSE,
    _ERROR_PLUGIN_EFUSE_CHECKSUM,
    _ERROR_PLUGIN_EFUSE_DATAINVALID,
    _ERROR_PLUGIN_EFUSE_SCALERTYPE,
    _ERROR_PLUGIN_EFUSE_ENTERISP,
    _ERROR_PLUGIN_EFUSE_USERCANCEL,
    _ERROR_PLUGIN_EFUSE_ISPDATACHECK,
    _ERROR_PLUGIN_EFUSE_ISPNOTNEED,
    _ERROR_PLUGIN_EFUSE_COMPARE,
    _ERROR_PLUGIN_EFUSE_READFAIL,
    _ERROR_PLUGIN_EFUSE_BIST_DO_NOTHING,
    _ERROR_PLUGIN_EFUSE_FACTORY_PART_ZERO,
    _ERROR_PLUGIN_EFUSE_READ_MAPPING,
    _ERROR_PLUGIN_EFUSE_CRC,
    _ERROR_PLUGIN_EFUSE_NOUSE,
    _ERROR_PLUGIN_EFUSE_TYPE_ERROR,
    _ERROR_PLUGIN_EFUSE_VGADET_NO_APPLY,
    _ERROR_PLUGIN_EFUSE_READ_UNFINISH,
    _ERROR_PLUGIN_EFUSE_FILE_LEN,

    _ERROR_PLUGIN_AUXCONFIG_SCALERTYPE = 0x500,
    _ERROR_PLUGIN_AUXCONFIG_COMMACCESS,
    _ERROR_PLUGIN_AUXCONFIG_ENTERISP,
    _ERROR_PLUGIN_AUXCONFIG_EXITISP,
    _ERROR_PLUGIN_AUXCONFIG_ENABLE,
    _ERROR_PLUGIN_AUXCONFIG_SETI2CSLAVEADDR,
    _ERROR_PLUGIN_AUXCONFIG_OPENFILE,
    _ERROR_PLUGIN_AUXCONFIG_FILETYPE,
    _ERROR_PLUGIN_AUXCONFIG_LIGHTUP,

    _ERROR_PLUGIN_DPSTATUS_SCALERTYPE = 0x600,

    _ERROR_DEVICE_OPTION_INDIRECT_NOT_SUPPORT_SEGMENT = 0x610,

    _ERROR_COMM_SMBUS_INIT_FAIL = 0x700,
    _ERROR_COMM_SMBUS_PARAMETER,
    _ERROR_COMM_SMBUS_READ_FAIL,
    _ERROR_COMM_SMBUS_WRITE_FAIL,
    _ERROR_COMM_SMBUS_NOT_SUPPORT,
    _ERROR_COMM_SMBUS_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_ECSMBUS_HOST_WRITE,
    _ERROR_COMM_ECSMBUS_HOST_READ,
    _ERROR_COMM_ECSMBUS_IBF_FULL,
    _ERROR_COMM_ECSMBUS_OBF_EMPTY,
    _ERROR_COMM_SMBUS_BLOCK_READ_DATA_LENGTH_ERROR,
    _ERROR_COMM_SMBUS_AUTO_DETECT_FAIL,
    _ERROR_COMM_SMBUS_LINUX_SET_SLAVE_ADDR,
    _ERROR_COMM_SMBUS_LINUX_READ_BYTE_FAIL,
    _ERROR_COMM_SMBUS_LINUX_WRITE_BYTE_FAIL,
    _ERROR_COMM_SMBUS_LINUX_READ_BYTE_DATA_FAIL,
    _ERROR_COMM_SMBUS_LINUX_WRITE_BYTE_DATA_FAIL,
    _ERROR_COMM_SMBUS_LINUX_READ_WORD_DATA_FAIL,
    _ERROR_COMM_SMBUS_LINUX_WRITE_WORD_DATA_FAIL,
    _ERROR_COMM_SMBUS_LINUX_READ_BLOCK_DATA_FAIL,
    _ERROR_COMM_SMBUS_LINUX_WRITE_BLOCK_DATA_FAIL,


    _ERROR_COMM_AUX_INIT_FAIL = 0x800,
    _ERROR_COMM_AUX_PARAMETER,
    _ERROR_COMM_AUX_READ_FAIL,
    _ERROR_COMM_AUX_WRITE_FAIL,
    _ERROR_COMM_AUX_NOT_SUPPORT,
    _ERROR_COMM_AUX_NATIVE_WRITE_FAIL,
    _ERROR_COMM_AUX_NATIVE_READ_FAIL,
    _ERROR_COMM_AUX_I2C_PAGELENGTH,
    _ERROR_COMM_AUX_NATIVE_PAGELENGTH,

    _ERROR_PLUGIN_DPCD_USERSTOP = 0x900,
    _ERROR_PLUGIN_DPCD_FILE_LENGTH,
    _ERROR_PLUGIN_DPCD_SCALERTYPE,
    _ERROR_PLUGIN_DPCD_AUXWRITE,
    _ERROR_PLUGIN_DPCD_LOAD_FILE,
    _ERROR_PLUGIN_DPCD_ILLEGAL_FILE,
    _ERROR_PLUGIN_DPCD_WRITE_REG_FAIL,

    _ERROR_PLUGIN_EDID_USERSTOP = 0xA00,
    _ERROR_PLUGIN_EDID_WRITECHECK,
    _ERROR_PLUGIN_EDID_IICCMDINCOMPLETE,
    _ERROR_PLUGIN_EDID_ENABLEDDCRAM,
    _ERROR_PLUGIN_EDID_DISABLEDDCRAM,
    _ERROR_PLUGIN_EDID_ILLEGAL_FILE,
    _ERROR_PLUGIN_EDID_AUX_UNSUPPORT_DERICT_MODE,
    _ERROR_PLUGIN_EDID_INTERNAL_NOT_WRITE,
    _ERROR_PLUGIN_EDID_ILLEGAL_HEADER,
    _ERROR_PLUGIN_EDID_BASE_CHECKSUM_ERROR,
    _ERROR_PLUGIN_EDID_EXTENSION_CHECKSUM_ERROR,
    _ERROR_PLUGIN_EDID_CEA_DETAILED_DATA_ILLEGAL,
    _ERROR_PLUGIN_EDID_ACCESS_METHOD_ILLEGAL,

    _ERROR_COMM_REALTEKUSB_FAIL_SELECTDEVICE = 0xB00,
    _ERROR_COMM_REALTEKUSB_NOT_SUPPORT,
    _ERROR_COMM_REALTEKUSB_INVALID_PARAMETER,
    _ERROR_COMM_REALTEKUSB_WRITEFILE_FAIL,
    _ERROR_COMM_REALTEKUSB_WRITEFILE_LENGTH,
    _ERROR_COMM_REALTEKUSB_READFILE_FAIL,
    _ERROR_COMM_REALTEKUSB_READFILE_LENGTH,
    _ERROR_COMM_REALTEKUSB_RECEIVEDATA_CHECKSUM,
    _ERROR_COMM_REALTEKUSB_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_REALTEKUSB_I2C_READCOUNT,
    _ERROR_COMM_REALTEKUSB_I2C_SPEED_UNSUPPORT,
    _ERROR_COMM_REALTEKUSB_RESET_FW,
    _ERROR_COMM_REALTEKUSB_DRIVER_INSTALL,
    _ERROR_COMM_REALTEKUSB_I2C_START,//0xB0D
    _ERROR_COMM_REALTEKUSB_I2C_NOACK,
    _ERROR_COMM_REALTEKUSB_I2C_POLLING,
    _ERROR_COMM_REALTEKUSB_I2C_INVALID_PARAMS,// 0xB10
    _ERROR_COMM_REALTEKUSB_I2C_CHECK_HIGHSCL,
    _ERROR_COMM_REALTEKUSB_I2C_CHECKSUM,
    _ERROR_COMM_REALTEKUSB_GETDEVICEPATH_FAIL,
    _ERROR_COMM_REALTEKUSB_DEVICEPATH_ILLEGAL,

    _ERROR_MP_EFUSE_LOAD_CONFIGFILE = 0xC00,
    _ERROR_MP_EFUSE_ILLEGAL_SCALERTYPE,
    _ERROR_MP_EFUSE_ILLEGAL_FILETYPE,
    _ERROR_MP_EFUSE_NONE_FILE,
    _ERROR_MP_EFUSE_ILLEGAL_PROGRAMMETHOD,
    _ERROR_MP_EFUSE_ILLEGAL_ISPOPTION,

    // ISP
    _ERROR_PLUGIN_ISP_OPEN_FILE_FAIL= 0xD00,
    _ERROR_PLUGIN_ISP_CANCEL,
    _ERROR_PLUGIN_ISP_LOADANSI_FAIL,
    _ERROR_PLUGIN_ISP_FLASH_MISMATCH_USE_DEFAULT_VALUE,
    _ERROR_PLUGIN_ISP_WRITE_FIRST_PAGE_ERROR,
    _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ERASE_FAIL,// 5
    _ERROR_PLUGIN_ISP_CRC_DIFFERENT_ISP_FAIL,
    _ERROR_PLUGIN_ISP_FLASH_FILE_ILLEAGL,
    _ERROR_PLUGIN_ISP_BANK_NO_ENOUGH,
    // Auto detect which bank need to ISP, when not need, return this
    _ERROR_PLUGIN_ISP_NO_NEED_CONTINUE,
    _ERROR_PLUGIN_ISP_PREPARE_DATA_FAIL, // A
    _ERROR_PLUGIN_ISP_BANK0_NO_ENOUGH_TO_STORE_SETTING,
    _ERROR_PLUGIN_ISP_SMBUS_SET_BLOCK_TYPE_FAIL,
    _ERROR_PLUGIN_ISP_SCALER_NOT_SUPPORT,
    _ERROR_PLUGIN_ISP_FAIL,
    // Auto search file in current dir, but no file
    _ERROR_PLUGIN_ISP_AUTO_SEARCH_NO_FILE,
    // Auto search file in current dir, but no *.h04(if user code begins at 4)
    _ERROR_PLUGIN_ISP_AUTO_SEARCH_NO_USER_CODE_BEGIN_FILE,// 10
    _ERROR_PLUGIN_ISP_AUTO_SEARCH_MORETHAN_ONE_FILE_MEET, 
    _ERROR_PLUGIN_ISP_PARA_ILLEGAL,
    // For HP AIO, just _SCALER_RL6193, _SCALER_RL6297
    _ERROR_PLUGIN_ISP_SCALER_IC_MISMATCH,
    _ERROR_PLUGIN_ISP_UNDEFINE_PNL_MODE,
    _ERROR_PLUGIN_ISP_ILLEGAL_HP_AIO_BIG_BIN_FILE,
    _ERROR_PLUGIN_ISP_SCALER_ID_MISMATCH,
    _ERROR_PLUGIN_ISP_PROJECT_NAME_MISMATCH,
    _ERROR_PLUGIN_ISP_FLASH_MISMATCH_6420,
    _ERROR_PLUGIN_ISP_SCALER_MISMATCH_6420,
    _ERROR_PLUGIN_ISP_AIO_SETTING_ILLEGAL,
    _ERROR_PLUGIN_ISP_NOT_FIND_AIO_SETTING_FILE,
    _ERROR_PLUGIN_ISP_NOT_FIND_AIO_SCALER_INFO,
    _ERROR_PLUGIN_ISP_NOT_FIND_AIO_PANEL_INFO,
    _ERROR_PLUGIN_ISP_NOT_FIND_AIO_FW_FILE,
    _ERROR_PLUGIN_ISP_BUTTON_DISABLE,
    _ERROR_PLUGIN_ISP_DDCCI_CHECK_FAIL,
    _ERROR_PLUGIN_ISP_ENABLE_ISP_CHANNEL_FAIL,
    _ERROR_PLUGIN_ISP_CHECK_MACHINE_ID_FAIL,
    _ERROR_PLUGIN_ISP_CHECK_DATA_FAIL, //0x23
    _ERROR_PLUGIN_ISP_DEBUG_MODE_ERROR,
    _ERROR_PLUGIN_ISP_GET_BEING_UPDATE_FW_VER_FAIL,
    _ERROR_PLUGIN_ISP_GET_CURRENT_FW_VER_FAIL,
    _ERROR_PLUGIN_ISP_VER_COMPARE_FAIL,
    _ERROR_PLUGIN_ISP_SWITCH_TO_BOOT_CODE,
    _ERROR_PLUGIN_ISP_QHD_SIGN_FAIL,
    _ERROR_PLUGIN_ISP_QHD_POLLING_SIGN_FINISH_FAIL,//0x2A
    _ERROR_PLUGIN_ISP_QHD_POLLING_SLAVE_FAIL,
    _ERROR_PLUGIN_ISP_QHD_GET_SIGN_STATUS_FAIL,
    _ERROR_PLUGIN_ISP_COPY_BANK_OPEN_FW_FAIL,
    _ERROR_PLUGIN_ISP_COPY_BANK_NOT_NEED_ISP,
    _ERROR_PLUGIN_ISP_COPY_BANK_UPDATE_COMBINE_VER_FAIL,
    _ERROR_PLUGIN_ISP_COPY_BANK_POLLING_FW_FINISH_FAIL,
    _ERROR_PLUGIN_ISP_COPY_BANK_EQUAL_INSTALLED_VERSION,
    _ERROR_PLUGIN_ISP_COPY_BANK_LESS_THAN_INSTALLED_VERSION,
    _ERROR_PLUGIN_ISP_FW_VERSION_NOT_NEW,
    _ERROR_PLUGIN_ISP_FW_VERSION_NEW,
	_ERROR_PLUGIN_ISP_CMD_STRING_TO_BYTE,
	_ERROR_PLUGIN_ISP_SPECIFIED_FLASH_NAME_EMPTY,
	_ERROR_PLUGIN_ISP_NOT_FIND_SPECIFIED_FLASH_INFO,
	_ERROR_PLUGIN_ISP_WRITE_FLASH_SR_OPCODE,
	_ERROR_PLUGIN_ISP_FLASH_MAP_EMPTY,  
	_ERROR_PLUGIN_ISP_FW_MAP_EMPTY,
	_ERROR_PLUGIN_ISP_LOAD_ONE_BANK_FW,
	_ERROR_PLUGIN_ISP_ONLY_CHIP_ERASE_HAVE_RESERVE_SETTING,
    _ERROR_PLUGIN_ISP_DEBUG_MODE_SWTICH_DDCCI_MODE_FAIL,
    _ERROR_PLUGIN_ISP_FACTORY_MODE_SWTICH_DDCCI_MODE_FAIL,
    _ERROR_PLUGIN_ISP_DDCCI_COMMUNICATION_HANDSHAKE_FAIL,
    _ERROR_PLUGIN_ISP_POLLING_FW_SIGNATURE_FINISH_FAIL,
    _ERROR_PLUGIN_ISP_TARGET_FLASH_BANK_DUPLICATION,
    _ERROR_PLUGIN_ISP_ALL_SLAVE_ADDR_NACK,
	_ERROR_PLUGIN_ISP_DO_ISP_NO_INITIAL,
	_ERROR_PLUGIN_ISP_PROGRESS_SET_RANGE,

    _ERROR_PLUGIN_EDPEEPROM_SET_DEFAULT_VALUE_FAIL = 0xE00,
    _ERROR_PLUGIN_EDPEEPROM_LOAD_FILE,
    _ERROR_PLUGIN_EDPEEPROM_ILLEGAL_FILE,
    _ERROR_PLUGIN_EDPEEPROM_USERSTOP,

    _ERROR_PLUGIN_ISP_EDID_ENTERNISP = 0xF00,
    _ERROR_PLUGIN_ISP_EDID_OPENEDIDFILE,
    _ERROR_PLUGIN_ISP_EDID_ERRORFILELENTH,
    _ERROR_PLUGIN_ISP_EDID_OPENFLASHDAT,
    _ERROR_PLUGIN_ISP_EDID_CRC_CHECK_FAIL,
    _ERROR_PLUGIN_ISP_EDID_FAIL,
    _ERROR_PLUGIN_ISP_EDID_FLASHSIZE_ERROR,

    _ERROR_GRID_EMPTY_VALUE = 0x1000,
    _ERROR_GRID_ILLEGAL_VALUE,

    _ERROR_PLUGIN_MP_ISP_CONFIGFILE = 0x1100,
    _ERROR_PLUGIN_MP_ISP_SCALERTYPE,
    _ERROR_PLUGIN_MP_ISP_PROGRAMMETHOD,
    _ERROR_PLUGIN_MP_ISP_PROGRAMFW,
    _ERROR_PLUGIN_MP_ISP_PROGRAMEDID,
    _ERROR_PLUGIN_MP_ISP_2NDEEPROMADDR,
    _ERROR_PLUGIN_MP_ISP_PROGRAMCOUNT,
    _ERROR_PLUGIN_MP_ISP_1STROMSPEED,
    _ERROR_PLUGIN_MP_ISP_2NDROMSPEED,
    _ERROR_PLUGIN_MP_ISP_DELAYTIME,

    _ERROR_PLUGIN_MP_FW_VERSION_CONFIGFILE = 0x1200,
    _ERROR_PLUGIN_MP_FW_VERSION_SCALERTYPE,
    _ERROR_PLUGIN_MP_FW_VERSION_PROGRAMMETHOD,
    _ERROR_PLUGIN_MP_FW_VERSION_DELAYTIME,
    _ERROR_PLUGIN_MP_FW_VERSION_FWVERSION_FORMAT,
    _ERROR_PLUGIN_MP_FW_VERSION_FW_COMPARE_FAIL,

    _ERROR_PLUGIN_DEBUG_MESSAGE_CHECKSUM_ERROR = 0x1300,

    // RTDTool
    _ERROR_RTDTOOL_FIND_NO_SCALER_INFO = 0x1400,
    _ERROR_RTDTOOL_MORE_THEN_ONE_SCALER_HAVE_SAME_ID,
    _ERROR_RTDTOOL_MORE_THEN_ONE_SCALER_HAVE_SAME_NAME,
    _ERROR_RTDTOOL_CAN_NOT_WRITE_TO_PROGRAM_FILES,
    _ERROR_RTDTOOL_CURRENT_IC_FORBIDDEN,
    _ERROR_RTDTOOL_CURRENT_IC_WARNING,
    _ERROR_RTDTOOL_USER_WANT_RETURN,
    // Flash Plugin
    _ERROR_PLUGIN_FLASH_USER_CANCEL_READING = 0x1500,

    // GT Plugin
    _ERROR_PLUGIN_GT_CMD_ERROR = 0x1600,
    _ERROR_PLUGIN_GT_TXT_NO_CMD,
    _ERROR_PLUGIN_GT_BYTES_TO_WRITE_NO_ENOUGH,
    _ERROR_PLUGIN_GT_IGNORE_CMD,
    _ERROR_PLUGIN_GT_READ_CMD_LOST_CHECK_VALUE,
    _ERROR_PLUGIN_GT_OUT_OF_BUFFER,
    _ERROR_PLUGIN_GT_MORE_THAN_ONE_CMD,
    _ERROR_PLUGIN_GT_VALUE_MORE_BYTE,

    // Ram Plugin
    _ERROR_PLUGIN_RAM_ERROR_VALUE = 0x1700,
    _ERROR_PLUGIN_RAM_MODIFY_REG_FAIL,
    _ERROR_PLUGIN_RAM_READ_CANCEL,

    _ERROR_PINSHARVERIFY_ERROR_COMPARE_VALUE = 0x1800,
    _ERROR_PINSHARVERIFY_ERROR_CREATE_REPORT_FILE,
    _ERROR_PINSHARVERIFY_ERROR_SARADC_INDEX_EMPTY,
    _ERROR_PINSHARVERIFY_ERROR_SARADC_CLK_DIV_ILLEGAL,
    _ERROR_PINSHARVERIFY_ERROR_NO_DDC_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_WRITE_READ_DIFFERENT,
    _ERROR_PINSHARVERIFY_ERROR_NO_I2C_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_ADC_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_INTIRQ_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_TIMER_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_VIHVIL_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_TESTPIN_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_CLKO_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_NO_SLEWCTRL_ENOUGH_INFO,
    _ERROR_PINSHARVERIFY_ERROR_ADC_TIME_OUT,
    _ERROR_PINSHARVERIFY_IIC_TRANSCATION_ERROR,
    _ERROR_PINSHARVERIFY_IIC_TIME_OUT,
    _ERROR_PINSHARVERIFY_IIC_EEPROM_TEST_FAIL,

    _ERROR_SCOPE_GET_DUTY_FAIL = 0x1900,
    _ERROR_SCOPE_GET_FREQ_FAIL,
    _ERROR_INSTRUMENT_INIT_SCOPE_FAIL,
    _ERROR_INSTRUMENT_INIT_POWERSUPPLY_FAIL,
    _ERROR_INSTRUMENT_INIT_INSTRUMENT_FAIL,
    _ERROR_POWERSUPPLY_SET_VOLTAGE_FAIL,//1905
    _ERROR_INSTRUMENT_ERROR_START,
    // About instrument
    // Start
    _ERROR_INSTRUMENT_INIT_FAIL,
    _ERROR_POWER_SUPPLY_NOT_SET_OUTPUT_ON,
    _ERROR_POWER_SUPPLY_SET_VOLT_TIME_OUT,
    _ERROR_POWER_SUPPLY_GET_PORT_SELECTION_FAIL,//190aa
    _ERROR_POWER_SUPPLY_SET_PORT_SELECTION_FAIL,
    _ERROR_POWER_SUPPLY_GET_OUTPUT_STATE_FAIL,
    _ERROR_POWER_SUPPLY_SET_OUTPUT_STATE_FAIL,
    _ERROR_POWER_SUPPLY_SET_VOLT_FAIL,
    _ERROR_POWER_SUPPLY_GET_VOLT_FAIL,
    _ERROR_POWER_SUPPLY_MEASURE_VOLT_FAIL,//1910
    _ERROR_POWER_SUPPLY_SET_REMOTE_OR_LOCAL_FAIL,
    _ERROR_POWER_SUPPLY_SET_RANGE_FAIL,
    _ERROR_POWER_SUPPLY_SET_CURRENT_FAIL,
    _ERROR_SCOPE_MEASURE_AVERAGE_VOLTAGE_FAIL,
    _ERROR_SCOPE_SET_THRESHOLD_VALUE_FAIL,//1915
    _ERROR_SCOPE_MEASURE_FALL_TIME_FAIL,
    _ERROR_SCOPE_MEASURE_RISE_TIME_FAIL,
    _ERROR_SCOPE_QUERY_THRESHOLDS_FAIL,
    _ERROR_SCOPE_SET_CHANNEL_DISPLAY_FAIL,
    _ERROR_SCOPE_MEAS_CLEAR_FAIL,//191a
    _ERROR_SCOPE_MEAS_FREQ_FAIL,
    _ERROR_SCOPE_MEAS_STAT_MEAN_FAIL,
    _ERROR_SCOPE_GET_MEAS_RESULTS_FAIL,
    _ERROR_SCOPE_SET_MEASURE_SOURCE_FAIL,
    _ERROR_SCOPE_SET_SWEEP_MODE_FAIL,
    _ERROR_SCOPE_SET_HORIZONTAL_SCALE_FAIL,//1920
    _ERROR_SCOPE_MEAS_VPP_VOLTAGE_FAIL,
    _ERROR_SCOPE_MEAS_VRMS_VOLTAGE_FAIL,
    _ERROR_SCOPE_SET_CHAN_OFFSET_FAIL,
    _ERROR_SCOPE_SET_CHAN_SCALE_FAIL,
    _ERROR_SCOPE_SET_TRIGGER_LEVEL_FAIL,//1925
    _ERROR_SCOPE_SET_FUNC_VCM_FAIL,
    _ERROR_SCOPE_SET_HISTOGRAM_FAIL,
    _ERROR_SCOPE_ENABLE_CGRADE_FAIL,
    _ERROR_SCOPE_MEAS_HIST_MEAN_FAIL,
    _ERROR_SCOPE_MEAS_HIST_PP_FAIL,//192a
    _ERROR_SCOPE_MEAS_HIST_STDDEV_FAIL,
    _ERROR_SCOPE_MEAS_HIST_MIN_FAIL,
    _ERROR_SCOPE_MEAS_HIST_MAX_FAIL,
    _ERROR_SCOPE_RUN_FAIL,
    _ERROR_SCOPE_STOP_FAIL,
    _ERROR_SCOPE_RESET_FAIL,//1930
    _ERROR_SCOPE_CLEAR_DISPLAY_FAIL,
    _ERROR_SCOPE_SET_TRIGGER_LEV_FIFTY_FAIL,
    _ERROR_SCOPE_GET_TRIGGER_LEV_FAIL,
    _ERROR_SCOPE_GET_TIME_POS_FAIL,
    _ERROR_SCOPE_SET_DISPLAY_GRATICULE_FAIL,//1935
    _ERROR_SCOPE_SET_TIMEBASE_RANGE_FAIL,
    _ERROR_SCOPE_MEAS_HIST_HITS_FAIL,
    _ERROR_SCOPE_MEAS_EDGE_TO_EDGE_FAIL,
    _ERROR_SCOPE_SET_TRIGGER_SOURCE_FAIL,
    _ERROR_SCOPE_SHOW_CHANNEL_FAIL,//193a
    _ERROR_SCOPE_MEAS_PERIOD_PERIOD_FAIL,
    _ERROR_SCOPE_MEAS_NPERIOD_FAIL,
    _ERROR_SCOPE_MEAS_PERIOD_FAIL,
    _ERROR_SCOPE_MEAS_STAT_ALL_FAIL,
    _ERROR_SCOPE_MEAS_STAT_MIN_FAIL,
    _ERROR_SCOPE_MEAS_STAT_MAX_FAIL,//1940
    _ERROR_SCOPE_MEAS_STAT_STDDEV_FAIL,
    _ERROR_SCOPE_MEAS_STAT_MEAS_FAIL,
    _ERROR_SCOPE_EZJIT_SETTING_FAIL,
    _ERROR_SCOPE_MEAS_MTREND_FREQ_FAIL,
    _ERROR_SCOPE_MEAS_MTREND_VPP_FAIL,
    _ERROR_SCOPE_RJDJ_SETTING_FAIL,
    _ERROR_SCOPE_GET_RJPJ_RMS_FAIL,
    // End

    _ERROR_PLUGIN_USBPHY_TIMEOUT = 0x1A00,


    _ERROR_PLUGIN_USBMEMORY_DATA_ERROR = 0x1B00,

    _ERROR_COMM_FTDIUSB_INIT_FAIL = 0x1C00,
    _ERROR_COMM_FTDIUSB_LOAD_DLL_FAIL,
    _ERROR_COMM_FTDIUSB_LOAD_FUNC_FAIL,
    _ERROR_COMM_FTDIUSB_SELECTDEVICE_FAIL,
    _ERROR_COMM_FTDIUSB_SET_MPSSE_MODE_FAIL,
    _ERROR_COMM_FTDIUSB_CONFIG_MPSSE_FAIL,
    _ERROR_COMM_FTDIUSB_SNED_CMD_FAIL,
    _ERROR_COMM_FTDIUSB_SNED_BYTE_ERROR,
    _ERROR_COMM_FTDIUSB_ENABLE_LOOPBACK_FAIL,
    _ERROR_COMM_FTDIUSB_BAD_COMMAND_DETECTION_FAIL,
    _ERROR_COMM_FTDIUSB_INIT_MPSSE_STATE_FAIL,//0x1C0A
    _ERROR_COMM_FTDIUSB_SET_CLK_DIVISOR_ERROR,
    _ERROR_COMM_FTDIUSB_INVALID_PARAMETER,
    _ERROR_COMM_FTDIUSB_WAIT_READ_QUEUE_TIMEOUT,
    _ERROR_COMM_FTDIUSB_GET_QUEUE_STATUS_FAIL,
    _ERROR_COMM_FTDIUSB_READ_FAIL,// 0x1C0F
    _ERROR_COMM_FTDIUSB_WRITE_FAIL,
    _ERROR_COMM_FTDIUSB_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_FTDIUSB_SPEED_NOT_SUPPORT,
    _ERROR_COMM_FTDIUSB_NOT_SUPPORT,
    _ERROR_COMM_FTDIUSB_GET_ACK_FAIL, // 0x1C14
    _ERROR_COMM_FTDIUSB_CHECK_I2C_SCL_FAIL,

    _ERROR_PLUGIN_OD_OPEN_FILE_FAIL = 0x1D00,
    _ERROR_PLUGIN_OD_ILLEGAL_FILE,
    _ERROR_PLUGIN_OD_DATA_LEN_ERROR,

    _ERROR_PLUGIN_MEASURE_MEAS_ERROR = 0x1E00,

    _ERROR_PLUGIN_AUXSNIFFER_FILE_TYPE = 0x1F00,
    _ERROR_PLUGIN_AUXSNIFFER_USER_STOP,

    _ERROR_ACEREDID_READ_EXTERNAL_FAIL = 0x2000,
    _ERROR_ACEREDID_READ_INTERNAL_FAIL,
    _ERROR_ACEREDID_READ_BOTH_FAIL,

    _ERROR_PLUGIN_GAMMA_OPEN_FILE_FAIL = 0x2100,
    _ERROR_PLUGIN_GAMMA_CHECK_DATA_FAIL,
    _ERROR_PLUGIN_GAMMA_SAVE_FILE_FAIL,

    _ERROR_COMM_GFXI2C_INIT_FAIL = 0x2200,
    _ERROR_COMM_GFXI2C_NOT_SUPPORT,
    _ERROR_COMM_GFXI2C_PARAMETER,
    _ERROR_COMM_GFXI2C_I2C_PAGELENGTH,
    _ERROR_COMM_GFXI2C_WRITE_FAIL,
    _ERROR_COMM_GFXI2C_READ_FAIL,

    _ERROR_SOCKET_INIT_SOCKET_FAIL = 0x2300,
    _ERROR_SOCKET_CONNECT_TO_SERVER_FAIL,

    _ERROR_GPIO_I2C_WRITE_FAIL = 0x2400,
    _ERROR_GPIO_I2C_READ_FAIL,
    _ERROR_DDCCI_ACCESS_TIME_OUT,
    _ERROR_DDCCI_CHECK_DATA_FAIL,
    _ERROR_DATA_OUT_OF_SECTOR,
    _ERROR_NOT_SUPPORT_DDCCI,

    _ERROR_HDCP_DEBUG_MODE_ERROR = 0x2500,
    _ERROR_HDCP_DATA_CHECK_ERROR,
    _ERROR_HDCP_NO_FILE_PATH,
    _ERROR_PLUGIN_HDCP_CMD_ILLEGAL,
    _ERROR_HDCP_FILE_LEN_ERROR,

    _ERROR_LVDSVERIFY_NO_GT_FILE = 0x2600,
    _ERROR_LVDSVERIFY_GT_FILE_ILLEGAL,
    _ERROR_LVDSVERIFY_CREATE_TEST_DATA,
    _ERROR_LVDSVERIFY_CREATE_REPORT_FILE,

    _ERROR_PLLVERIFY_NO_GT_FILE = 0X2700,
    _ERROR_PLLVERIFY_GT_FILE_ILLEGAL,

    _ERROR_EDP_CUSTOMER_LOAD_CONFIG_FAIL = 0x2800,
    _ERROR_EDP_CUSTOMER_ILLEGAL_SCALER_TYPE,
    _ERROR_EDP_CUSTOMER_ILLEGAL_PROGRAM_METHOD,
    _ERROR_EDP_CUSTOMER_ILLEGAL_FW_FILE,
    _ERROR_EDP_CUSTOMER_ILLEGAL_RETRY_CNT,
    _ERROR_EDP_CUSTOMER_LOAD_FW_FAIL,
    _ERROR_EDP_CUSTOMER_NOT_IN_FLASH_MODE,
    _ERROR_EDP_CUSTOMER_FLASH_NOT_SUPPORT,

    _ERROR_PG_ERROR_TIMING = 0x2900,
    _ERROR_PG_CHECK_PATTERN_VALUE,

    _ERROR_PLUGIN_MSTDEBUG_ILLEGAL_DELAY = 0x2A00,
    _ERROR_PLUGIN_MSTDEBUG_ILLEGAL_FIFO_DATA,

    _ERROR_COMM_USBDHUBI2C_NOT_SUPPORT = 0x2B00,
    _ERROR_COMM_USBDHUBI2C_INIT_FAIL,
    _ERROR_COMM_USBDHUBI2C_LOAD_DLL_FAIL,
    _ERROR_COMM_USBDHUBI2C_GET_FUNC_FAIL,
    _ERROR_COMM_USBDHUBI2C_NO_AVAILABLE_DEV,
    _ERROR_COMM_USBDHUBI2C_INVALID_PARAMETER,
    _ERROR_COMM_USBDHUBI2C_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_USBDHUBI2C_OPEN_DEV,
    _ERROR_COMM_USBDHUBI2C_SETBUSSPEED,
    _ERROR_COMM_USBDHUBI2C_WRITEI2C,
    _ERROR_COMM_USBDHUBI2C_READI2C,
    _ERROR_COMM_USBDHUBI2C_SEND_PACKET_FAIL,
    _ERROR_COMM_USBDHUBI2C_RECEIVE_PACKET_FAIL,

    _ERROR_PLUGIN_TRIM_OPENFILE = 0x2C00,
    _ERROR_PLUGIN_TRIM_FILETYPE,
    _ERROR_PLUGIN_TRIM_MALLOCBUF,
    _ERROR_PLUGIN_TRIM_BUF_NULL,

    _ERROR_PLUGIN_DONGLEISP_ITEM_CNT_ILLEGAL = 0x2D00,
    _ERROR_PLUGIN_DONGLEISP_MP_UI_SETTING,
    _ERROR_PLUGIN_DONGLEISP_MP_TRANSLATOR_OPEN_FAIL,
    _ERROR_PLUGIN_DONGLEISP_MP_TRANSLATOR_SIZE,
    _ERROR_PLUGIN_DONGLEISP_MP_UFP_OPEN_FAIL,
    _ERROR_PLUGIN_DONGLEISP_MP_UFP_SIZE,
    _ERROR_PLUGIN_DONGLEISP_MP_EMPTY_BANK,
    _ERROR_PLUGIN_DONGLEISP_MP_NO_TRIMMING_DATA,
    _ERROR_PLUGIN_DONGLEISP_MP_NO_HDCP_KEY,
    _ERROR_PLUGIN_DONGLEISP_MP_JUDGE_IC_FAIL,
    _ERROR_PLUGIN_DONGLEISP_MP_JUDGE_C2HDMI_ONLY,
    _ERROR_PLUGIN_DONGLEISP_MP_JUDGE_C2VGA_ONLY,
    _ERROR_PLUGIN_DONGLEISP_MP_WRITE_PID_VID_FAIL,
    _ERROR_PLUGIN_DONGLEISP_MP_LACK_OF_FW_FILE,
    _ERROR_PLUGIN_DONGLEISP_MP_ISP_CMD_ERROR,

    _ERROR_PLUGIN_READ_PUB_KEY_PARA_ILLEGAL = 0x2E00,
    _ERROR_PLUGIN_READ_PUB_KEY_ILLEGAL_HEADER,
    _ERROR_PLUGIN_READ_PUB_KEY_ILLEGAL_LEN,
    _ERROR_PLUGIN_READ_PUB_KEY_CKSM_FIAL,

    _ERROR_PLUGIN_CRCDEBUG_JUDGE_RX_SOURCE_FAIL = 0x2F00,
    _ERROR_PLUGIN_CRCDEBUG_USER_CANCEL_READING,

    _ERROR_COMM_TYPECI2C_NOT_SUPPORT = 0x3000,
    _ERROR_COMM_TYPECI2C_INIT_FAIL,
    _ERROR_COMM_TYPECI2C_LOAD_DLL_FAIL,
    _ERROR_COMM_TYPECI2C_GET_FUNC_FAIL,
    _ERROR_COMM_TYPECI2C_NO_AVAILABLE_DEV,
    _ERROR_COMM_TYPECI2C_INVALID_PARAMETER,
    _ERROR_COMM_TYPECI2C_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_TYPECI2C_OPEN_DEV,
    _ERROR_COMM_TYPECI2C_SETBUSSPEED,
    _ERROR_COMM_TYPECI2C_WRITEI2C,
    _ERROR_COMM_TYPECI2C_READI2C,

    _ERROR_COMM_TYPECUSB_NO_AVAILABLE_DEV = 0x3100,
    _ERROR_COMM_TYPECUSB_OPEN_DEV,
    _ERROR_COMM_TYPECUSB_INIT_FAIL,
    _ERROR_COMM_TYPECUSB_READ_REG,
    _ERROR_COMM_TYPECUSB_WRITE_REG,
    _ERROR_COMM_TYPECUSB_WRITE_FLASH_DATA,
    _ERROR_COMM_TYPECUSB_READ_FLASH_DATA,
    _ERROR_COMM_TYPECUSB_NOT_SUPPORT,
    _ERROR_COMM_TYPECUSB_WRITE_SYSEEPROM_FAIL,
    _ERROR_COMM_TYPECUSB_READ_SYSEEPROM_FAIL,
    _ERROR_COMM_TYPECUSB_HANDSHAKE_ERROR,
    _ERROR_COMM_TYPECUSB_SELECT_DEV,
    _ERROR_COMM_TYPECUSB_DM_EVENT_START,
    _ERROR_COMM_TYPECUSB_DM_EVENT_FINISH,
    _ERROR_COMM_TYPECUSB_DM_START,
    _ERROR_COMM_TYPECUSB_DM_END,
    _ERROR_COMM_TYPECUSB_DM_GET_VALUE,
    _ERROR_COMM_TYPECUSB_DM_GET_STRING,
    _ERROR_COMM_TYPECUSB_SEND_PACKET_FAIL,
    _ERROR_COMM_TYPECUSB_RECEIVE_PACKET_FAIL,

    _ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_LOCAL_FW_MEET = 0x3200,
    _ERROR_PLUGIN_AUXISPBOARD_NOT_FIND_LOCAL_FW_FILE,
    _ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_SCALER_FW_MEET,
    _ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_UFP_FW_MEET,
    _ERROR_PLUGIN_AUXISPBOARD_MORETHAN_ONE_PROGRAM_DFP_FW_MEET,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_SCALER_FW,
    _ERROR_PLUGIN_AUXISPBOARD_OPEN_LOCAL_FW_FAIL,
    _ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_SCALER_FW_FAIL,
    _ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_UFP_FW_FAIL,
    _ERROR_PLUGIN_AUXISPBOARD_OPEN_PROGRAM_DFP_FW_FAIL,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_LOCAL_BIN_SIZE,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_LOCAL_BIN_BANK2,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_SCALER_BIN_SIZE,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_UFP_BIN_SIZE,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_DFP_BIN_SIZE,
    _ERROR_PLUGIN_AUXISPBOARD_ILLEGAL_PROGRAM_FW,
    _ERROR_PLUGIN_AUXISPBOARD_UNKNOWN_PROGRAM_TYPE,

    _ERROR_PLUGIN_DDR_SPACE_WRTIE  = 0x3300,

    _ERROR_PLUGIN_ERROR_COUNT_COMM_NOT_SUPPORT  = 0x3400,
    _ERROR_PLUGIN_ERROR_COUNT_SCALER_NOT_SUPPORT,
    _ERROR_PLUGIN_ERROR_COUNT_LANE_COUNT_ERROR,

    _ERROR_RS232_INITIAL_FAIL = 0x3500,
    _ERROR_RS232_INSTRUMNET_NO_ACK,

    _ERROR_NETWORK_INITIAL_FAIL = 0x3600,
    _ERROR_NETWORK_INSTRUMNET_NO_ACK,

    _ERROR_RSAUTOTEST_HDMI_NOT_SUPPORT = 0x3700,
    _ERROR_RSAUTOTEST_DP_VERSION_NOT_SUPPORT,
    _ERROR_RSAUTOTEST_DP_NOT_SUPPORT,
    _ERROR_RSAUTOTEST_OUTPUT_DVS_TSET_SIGNAL_FAIL,

    _ERROR_PLUGIN_GETFEVERSION_FWVER_COMPARE_FAIL = 0x3800,
    _ERROR_PLUGIN_GETFEVERSION_USB_COMPARE_FAIL,
    _ERROR_PLUGIN_GETFEVERSION_PDCC_COMPARE_FAIL,
    _ERROR_PLUGIN_GETFEVERSION_STRING_COMPARE_FAIL,

    _ERROR_COMM_GLHUBI2C_NOT_SUPPORT = 0x3900,
    _ERROR_COMM_GLHUBI2C_INIT_FAIL,
    _ERROR_COMM_GLHUBI2C_LOAD_DLL_FAIL,
    _ERROR_COMM_GLHUBI2C_GET_FUNC_FAIL,
    _ERROR_COMM_GLHUBI2C_NO_AVAILABLE_DEV,
    _ERROR_COMM_GLHUBI2C_INVALID_PARAMETER,
    _ERROR_COMM_GLHUBI2C_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_GLHUBI2C_OPEN_DEV,
    _ERROR_COMM_GLHUBI2C_SETBUSSPEED,
    _ERROR_COMM_GLHUBI2C_WRITEI2C,
    _ERROR_COMM_GLHUBI2C_READI2C,

    _ERROR_COMM_VIAHUBI2C_NOT_SUPPORT = 0x3A00,
    _ERROR_COMM_VIAHUBI2C_INIT_FAIL,
    _ERROR_COMM_VIAHUBI2C_LOAD_DLL_FAIL,
    _ERROR_COMM_VIAHUBI2C_GET_FUNC_FAIL,
    _ERROR_COMM_VIAHUBI2C_NO_AVAILABLE_DEV,
    _ERROR_COMM_VIAHUBI2C_INVALID_PARAMETER,
    _ERROR_COMM_VIAHUBI2C_I2C_PAGELENGTH_UNSUPPORT,
    _ERROR_COMM_VIAHUBI2C_OPEN_DEV,
    _ERROR_COMM_VIAHUBI2C_SETBUSSPEED,
    _ERROR_COMM_VIAHUBI2C_WRITEI2C,
    _ERROR_COMM_VIAHUBI2C_READI2C = 0x3A0A,
    _ERROR_COMM_VIAHUBI2C_READ_EXCEED_MAX_LENGTH,
    _ERROR_COMM_VIAHUBI2C_WRITE_EXCEED_MAX_LENGTH,
    _ERROR_COMM_VIAHUBI2C_READ_LENGTH_INVALID,
    _ERROR_COMM_VIAHUBI2C_WRITE_LENGTH_INVALID,

    _ERROR_PLUGIN_PHY_CHECK_MAC_FAIL = 0x3B00,
    _ERROR_PLUGIN_PHY_DETECT_VSYNC_TIME_OUT,
    
    _ERROR_CPDEVICECOMM_NOT_SUPPORT = 0x3C00,

    _ERROR_LINUX_I2C_INIT_FAIL = 0x3D00,
    _ERROR_LINUX_I2C_SET_SLAVE_ADDRESS,
    _ERROR_LINUX_I2C_WRITE_FAIL,   
    _ERROR_LINUX_I2C_READ_FAIL,   


    _ERROR_END = 0xFFFF,
}STRUCT_ENUM_ERROR_TYPE;

#endif // End of #ifndef _ERROR_DEFINE_H_
